<script lang="ts">
  import { flip } from "svelte/animate";
  import { fade } from "svelte/transition";
  import {
    createActionDispatcher,
    getAceHolders,
    getCardSuit,
    getCardValue,
    getGridInfo,
    getPlaceablePositions,
    isValidNextStep,
    isValidPath,
    parsePosition,
    scorePath,
  } from "../utils";
  import Card from "./Card.svelte";
  import { receive, send } from "./cardTransition";
  import Pile from "./Pile.svelte";
  import SuitIcon from "./SuitIcon.svelte";

  const dispatch = createActionDispatcher();

  export let player: Player;
  export let state: GameState;
  export let isUser: boolean = false;
  export let isActive: boolean = false;
  export let scoringSuits: Suit[] | undefined = undefined;

  $: handsAreRevealed =
    state.phase.kind === "Scoring" || state.phase.kind === "End";

  $: aceHolders = handsAreRevealed ? getAceHolders(state.players) : {};

  function getHandCardStyle(
    idx: number,
    handSize: number,
    isUser: boolean,
    isSpeaking?: boolean
  ): string {
    const rotationStep = 4;
    const startRotation = ((1 - handSize) / 2) * rotationStep;
    const rotation = startRotation + rotationStep * idx;

    const translateX = isSpeaking ? (isUser ? "-33%" : "-75%") : "0";
    return `
      --rotate-hand-card: ${rotation}deg;
      --translate-y-hand-card: ${translateX};
    `;
  }

  let hand: CardId[];
  $: {
    hand = player.hand;
    if (isUser || handsAreRevealed) {
      hand.sort((a, b) => a - b);
    }
  }

  $: gridInfo = getGridInfo(Object.keys(player.played));

  let selectedCard: CardId | null;
  $: {
    if (selectedCard !== null) {
      if (state.phase.kind !== "Playing") {
        selectedCard = null;
      } else if (!player.hand.includes(selectedCard)) {
        selectedCard = null;
      }
    }
  }

  let selectedSuit: Suit | null = null;
  let selectedPath: CardPosition[] = [];
  $: if (selectedSuit === null) {
    selectedPath = [];
  }

  let scoredPaths: { [suit in Suit]?: Path } | null = null;
  $: if (state.phase.kind === "Scoring" || state.phase.kind === "End") {
    scoredPaths = state.phase.paths[player.id];
  } else {
    scoredPaths = null;
  }

  $: speaking =
    state.phase.kind === "Scoring" && scoringSuits && scoringSuits.length > 0;
</script>

<div class="wrapper" class:user={isUser}>
  {#each hand as card, idx (card)}
    {@const cardValue = getCardValue(card)}
    {@const cardSuit = getCardSuit(card)}
    {@const aceHolder = aceHolders[cardSuit]}

    <div
      class="hand-card"
      style={getHandCardStyle(idx, player.hand.length, isUser, speaking)}
    >
      <div in:receive={{ key: card }} out:send={{ key: card }}>
        <button
          class="invisibutton"
          class:selected={selectedCard === card}
          disabled={!isUser ||
            !isActive ||
            (state.phase.kind !== "Discarding" &&
              state.phase.kind !== "Playing")}
          on:click={() => {
            if (state.phase.kind === "Playing") {
              if (card === selectedCard) {
                selectedCard = null;
              } else {
                selectedCard = card;
              }
            } else if (state.phase.kind === "Discarding") {
              dispatch({ kind: "Discard", card });
            }
          }}
        >
          <Card
            {card}
            facedown={!isUser && !handsAreRevealed}
            zero={cardValue === 8 && aceHolder && aceHolder !== player.id}
          />
        </button>
      </div>
    </div>
  {/each}

  <gs6-player-box playerid={player.id} thinking={isActive} {speaking}>
    {#if speaking}
      <div class="scoring" slot="speech">
        I'm scoring
        {#each scoringSuits as suit, suitIdx}
          <SuitIcon
            {suit}
          />{#if scoringSuits.length > 2 && suitIdx === scoringSuits.length - 2}{", and "}
          {:else if scoringSuits.length === 2 && suitIdx === 0}
            {" and "}
          {:else if scoringSuits.length > 2 && suitIdx < scoringSuits.length - 1}{", "}
          {:else if suitIdx === scoringSuits.length - 1}.
          {/if}
        {/each}
      </div>
    {/if}
  </gs6-player-box>

  {#if state.phase.kind === "Scoring" && isUser}
    <div class="wrapper-right">
      {#if isActive}
        <button
          class="primary"
          on:click={() => {
            dispatch({ kind: "Ready" });
          }}
        >
          I'm ready!
        </button>
      {:else}
        <button
          class="secondary"
          on:click={() => {
            dispatch({ kind: "Unready" });
          }}
        >
          Undo
        </button>
      {/if}
    </div>
  {/if}

  <div class="played-wrapper">
    <div
      class="played"
      style:--played-cols={gridInfo.cols}
      style:--played-rows={gridInfo.rows}
    >
      {#each Object.entries(player.played) as [position, card] (position)}
        {@const [x, y] = parsePosition(position)}

        <div
          class="played-card"
          style:--played-card-col={x - gridInfo.xMin + 1}
          style:--played-card-row={y - gridInfo.yMin + 1}
          animate:flip={{ duration: 500 }}
        >
          <div in:receive={{ key: card }} out:send={{ key: card }}>
            <button
              class="path invisibutton"
              class:selected={selectedPath.includes(position)}
              disabled={!selectedSuit ||
                !selectedPath ||
                !isValidNextStep(
                  player.played,
                  selectedSuit,
                  selectedPath,
                  position
                )}
              on:click={() => {
                selectedPath = [...selectedPath, position];
              }}
            >
              <Card {card} bigText />
            </button>
          </div>
        </div>
      {/each}

      {#if isUser && isActive && state.phase.kind === "Playing"}
        {#each getPlaceablePositions(Object.keys(player.played)) as position (position)}
          {@const [x, y] = parsePosition(position)}

          <div
            class="played-card"
            style:--played-card-col={x - gridInfo.xMin + 1}
            style:--played-card-row={y - gridInfo.yMin + 1}
            animate:flip={{ duration: 500 }}
          >
            <button
              class="invisibutton"
              disabled={selectedCard === null}
              on:click={() => {
                dispatch({ kind: "Play", card: selectedCard, position });
              }}
            >
              <Pile cards={[]} />
            </button>
          </div>
        {/each}
      {/if}

      {#if scoringSuits}
        <div class="score-counters">
          <ul>
            {#each selectedSuit ? [selectedSuit] : scoringSuits as suit (suit)}
              <li animate:flip transition:fade>
                <SuitIcon {suit} /> =
                {#if selectedSuit}
                  {scorePath(player.played, selectedPath) ?? "…"}
                {:else if scoredPaths?.[suit]}
                  {scorePath(player.played, scoredPaths[suit])}
                {:else}
                  0
                {/if}
                points
              </li>
            {/each}
          </ul>
        </div>
      {/if}
    </div>

    {#if isUser && isActive && state.phase.kind === "Scoring"}
      <div class="scoring-help">
        {#if selectedSuit}
          Select <SuitIcon suit={selectedSuit} /> path. ↑
        {:else}
          Select suit to score. ↓
        {/if}
      </div>
      <div class="score-suit-buttons">
        {#if !selectedSuit}
          {#each scoringSuits as suit}
            <button
              class="secondary small score-suit-button"
              on:click={() => {
                selectedSuit = suit;
              }}
            >
              <SuitIcon {suit} />
            </button>
          {/each}
        {:else}
          <button
            class="secondary"
            on:click={() => {
              selectedSuit = null;
            }}
          >
            Cancel
          </button>

          <button
            class="primary"
            disabled={!isValidPath(player.played, selectedSuit, selectedPath)}
            on:click={() => {
              dispatch({
                kind: "Score",
                path: selectedPath,
                suit: selectedSuit,
              });
              selectedSuit = null;
            }}
          >
            Confirm
          </button>
        {/if}
      </div>
    {/if}
  </div>
</div>

<style lang="scss">
  .wrapper {
    position: relative;
    min-width: 12em;

    .hand-card {
      font-size: 0.5rem;
    }
    &.user .hand-card {
      font-size: 0.85rem;
    }
  }

  .hand-card {
    position: absolute;
    top: 1rem;
    left: 50%;
    transform: translate(-50%, -100%) translateY(40em)
      translateY(var(--translate-y-hand-card)) rotate(var(--rotate-hand-card))
      translateY(-40em);

    button:not(:disabled) {
      cursor: pointer;
      transition: transform 0.2s;

      &:hover,
      &:focus {
        transform: translateY(-10%);
      }

      &.selected {
        outline: 4px solid rgb(109, 158, 204);
        outline-offset: 2px;
        border-radius: 2px;
        transform: translateY(-15%);
      }
    }
  }

  .invisibutton {
    text-align: inherit;
  }

  .played-wrapper {
    position: absolute;
    left: 50%;
    bottom: 0.5rem;

    transform: translate(-50%, 100%);
    display: flex;
    flex-direction: column;
    align-items: center;
  }

  .played {
    position: relative;
    --played-cols: 1;
    --played-rows: 1;

    font-size: 25%;

    display: grid;
    gap: 0.5em;
    place-content: center;

    grid-template-columns: repeat(var(--played-cols), auto);
    grid-template-rows: repeat(var(--played-rows), auto);
  }

  .played-card {
    position: relative;
    width: fit-content;

    grid-column: var(--played-card-col);
    grid-row: var(--played-card-row);
  }

  .played-card button {
    &:not(:disabled) {
      cursor: pointer;
    }
  }

  .score-counters {
    font-size: 1rem;
    position: absolute;
    top: 0;
    right: -1rem;
    transform: translate(100%, 0);
  }

  .scoring {
    white-space: nowrap;
  }

  .scoring-help {
    font-style: italic;
    white-space: nowrap;
    margin-top: 0.5rem;
    margin-bottom: 0.5rem;
  }

  .score-suit-buttons {
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
    gap: 0.25rem;
  }
  .score-suit-button {
    padding: 0.5em;
  }

  .path.selected {
    position: relative;
    &::after {
      content: "";
      position: absolute;
      inset: 0.5em;

      border: 1em solid rgb(109, 158, 204);
      border-radius: 50%;
    }
  }

  .wrapper-right {
    position: absolute;
    right: -0.5rem;
    top: 50%;
    transform: translate(100%, -50%);
  }
</style>
